use std::error::Error;

use itertools::Itertools;

fn main() -> Result<(), Box<dyn Error>> {
    let inp = include_str!("../input.txt");

    let (cargo, moves) = inp.split_once("\n\n").unwrap();

    let mut cargo: Vec<String> = cargo.split('\n').map(|x| x.to_string()).collect();

    let numbers = cargo.pop().unwrap();
    let numbers: Vec<usize> = numbers
        .split_ascii_whitespace()
        .map(|x| x.parse().unwrap())
        .collect_vec();

    let mut stack: Vec<Vec<char>> = vec![Vec::new(); numbers.len()];

    cargo.reverse();

    for i in numbers.iter() {
        for line in &cargo {
            {
                let index = 4 * (i - 1) + 1;
                let word = line.chars().nth(index as usize).unwrap();

                if word != ' ' {
                    stack[*i - 1].push(word);
                }
            }
        }
    }

    for m in moves.split_terminator('\n') {
        let m = m
            .replace("move ", "")
            .replace("from ", "")
            .replace("to ", "");
        let mut it = m.split(' ').map(|x| x.parse::<usize>().unwrap());

        let mov = it.next().unwrap();
        let from = it.next().unwrap() - 1;
        let to = it.next().unwrap() - 1;

        let len = stack[from].len();
        let crates = stack[from].split_off(len - mov);
        stack[to].extend(crates.iter().rev());
    }

    for x in &stack {
        print!("{}", x.last().unwrap());
    }
    println!();
    Ok(())
}
